Subject: Re: bug#55319: 28.1.50; Abugida not rendered correctly (MacOS)

From: Kai Ma <[email-masked]>
Date: Thu, 12 May 2022 16:26:49 +0800

> On May 12, 2022, at 16:10, Robert Pluim <[email-masked]> wrote:
> 
>>>>>> On Wed, 11 May 2022 23:43:36 +0800, Kai Ma <[email-masked]> said:
> 
>>> On May 9, 2022, at 10:38, Eli Zaretskii <[email-masked] <mailto:[email-masked]>> wrote:
>>> 
>>> Emacs doesn't discover composition rules. The composition rules are
>>> part of the Emacs code, see the various *.el files in lisp/language/
>>> directory. Some of these composition rules are derived automatically
>>> from character properties, see composite.el and characters.el (which
>>> cannot happen without Emacs knowing up-front about the properties).
> 
>    Kai> Thanks for this. I didn’t know Emacs needed to manually compose characters.
> 
>    Kai> Feel free to close this report, since it is due to my misunderstanding, not a real problem nor a real “wishlist”.
> 
>    Kai> BTW,
> 
>    Kai> I did try to follow language/*.el, and come with up the following code:
> 
>    Kai> (let* ((c "[\uED80-\uED9F]\\|\uEDAA\\|\uEDAB”) ; constant
> 
> ie: "[\uED80-\uED9F\uEDAA\uEDAB]”
> 
>    Kai>        (v "[\uEDA0-\uEDA9]”) ; vowel
>    Kai>        (cv (concat v c)))
> 
> You've called this 'cv', but itʼs actually 'vc'.
> 
>    Kai>   (set-char-table-range
>    Kai>    composition-function-table '(#xeda0 . #xeda9)
>    Kai>    (list 
>    Kai>     (vector cv 1 #'zbalermorna-shape-gstring)
>    Kai>     [nil 0 font-shape-gstring])))
> 
> Youʼre looking back from vowels, it might be easier to add entries for
> the consonants and look forward.
> 
>    Kai> (defun zbalermorna-shape-gstring (gstring direction)
>    Kai>   (message "shape %s" gstring) ; debugging
>    Kai>   gstring)
> 
>    Kai> But it doesn’t work as expected. For example, “ka” should be
>    Kai> composed, but the behavior here is “a” itself is composed,
>    Kai> and when the first rule is matched, only the consonant “k” is
>    Kai> sent to font-shape-gstring: only “k” is in the header.
> 
>    Kai> Have you any pointers? Thanks!
> 
> I think if you fix 'cv' this will work.

Thanks. I’ve got it work.

Besides the pattern problem, there were two missing pieces:
(1) canonical-combining-class, and 
(2) `compose-'  to actually compose it into one glyph. `font-shape-gstring' alone does not work.

This is the result:

(defun zbalermorna-setup ()
  "Set up the composition rules for zbalermonrna."
  (interactive)

  (dolist (v (number-sequence #xeda0 #xeda9))
    (put-char-code-property v 'canonical-combining-class (encode-composition-rule '(tc . bc))))

  (let* ((c "\\([\uED80-\uED97]\\|\uEDAA\\|\uEDAB\\)")
         (v "[\uEDA0-\uEDA9]")
         (dot "\uED89")
         (h "\uED8A")
         (pattern1 (concat c v))
         (pattern2 (concat v h v)))
    (set-char-table-range
     composition-function-table '(#xeda0 . #xeda9)
     (list (vector pattern2 2 #'compose-gstring-for-graphic)
           (vector pattern1 1 #'compose-gstring-for-graphic)
           [nil 0 font-shape-gstring]))))